import nlp from 'compromise';

import helpers from 'wink-helpers';

import './style.css';

const CHUNK_SIZE = 1024;

function scramble(words) {
  const w = words.map(o => o.text());
  return helpers.array.shuffle(w);
}

function make_fragments(verbs, nouns) {
  const fragments = [];
  while( verbs.length > 0 && nouns.length > 0 ) {
    const v = verbs.pop();
    const n = nouns.pop();
    if( nouns.length > 0 && Math.random() > 0.5 ) {
      const n2 = nouns.pop();
      fragments.push(`${n} ${v} ${n2}`);
    } else{
      fragments.push(`${n} ${v}`);
    }
  }
  return fragments;
}

async function damned_fort() {
  const response = await fetch("./damned.txt");
  if( !response.ok ) {
    throw new Error(`Response failed: ${response.status}`)
  }
  const text = await response.text();

  let i = 0;
  return () => {
    const chunk = text.substring(i, i + CHUNK_SIZE);
    if( chunk ) {
      const div = document.getElementById("page");
      const doc = nlp(chunk);
      const v = scramble(doc.verbs());
      const n = scramble(doc.nouns());
      const fragments = make_fragments(n, v);
      div.innerHTML = `<p>${fragments.join('<br />')}</p>`;
      i +=CHUNK_SIZE;
    } else {
      i = 0;
    }
  }
}

async function main() {

  const next_ctrl = await damned_fort();
  const next = document.getElementById("nextPage");

  next.addEventListener("click", (e) => { next_ctrl(); });
  next_ctrl();
}


main();